import moment from 'moment';
const app = getApp();
const formatTime = date => {
  const year = date.getFullYear()
  const month = date.getMonth() + 1
  const day = date.getDate()
  const hour = date.getHours()
  const minute = date.getMinutes()
  const second = date.getSeconds()

  return `${[year, month, day].map(formatNumber).join('/')} ${[hour, minute, second].map(formatNumber).join(':')}`
}
const getWeekByDate = dates => {
  let show_day = new Array('周日', '周一', '周二', '周三', '周四', '周五', '周六');
  let date = new Date(dates);
  date.setDate(date.getDate());
  let day = date.getDay();
  return show_day[day];
}

const formatNumber = n => {
  n = n.toString()
  return n[1] ? n : `0${n}`
}

function formatDate(date) {
  var year = date.getFullYear();
  var month = date.getMonth() + 1;
  var day = date.getDate();
  if (month < 10)
    month = "0" + month;
  if (day < 10)
    day = "0" + day;
  return [year, month, day].map(formatNumber).join('-');
}

//时间戳转日期,falg:true表示只要年月日,part: year month date
function toDate(number, flag, part) {
  var n = number;
  var date = new Date(parseInt(n) * 1000);
  var y = date.getFullYear();
  var m = date.getMonth() + 1;
  m = m < 10 ? ('0' + m) : m;
  var d = date.getDate();
  d = d < 10 ? ('0' + d) : d;
  var h = date.getHours();
  h = h < 10 ? ('0' + h) : h;
  var minute = date.getMinutes();
  var second = date.getSeconds();
  minute = minute < 10 ? ('0' + minute) : minute;
  second = second < 10 ? ('0' + second) : second;
  if (flag) {
    if (part == "year") {
      return y;
    } else if (part == "month") {
      return m;
    } else if (part == "date") {
      return n;
    }
    return y + '-' + m + '-' + d;
  }
  return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
}
//当前日期加减天数,falg:true表示只要年月日
function mathChangeDate(date, method, days, flag) {
  //method:'+' || '-'
  //ios不解析带'-'的日期格式，要转成'/'，不然Nan，切记
  var dateVal = date.replace(/-/g, '/');
  var timestamp = Date.parse(dateVal);
  if (method == '+') {
    timestamp = timestamp / 1000 + 24 * 60 * 60 * days;
  } else if (method == '-') {
    timestamp = timestamp / 1000 - 24 * 60 * 60 * days;
  }
  return toDate(timestamp, flag);
}


/**
 * 封封微信的的request
 */
function request(url, data = {}, method = "GET") {
  var url=url;
    // console.log(app.globalData);
    let isUat=wx.getStorageSync('isUat');
     if(!isUat){
      url=url.replace('uat.','')
     }
  return new Promise(function (resolve, reject) {
    
    wx.request({
      url: url,
      data: data,
      method: method,
      header: {
        'Content-Type': 'application/json',
        'X-JZ-Token': wx.getStorageSync('token')
      },
      success: function (res) {

        if (res.statusCode == 200) {

          if (res.data.errno == 501||res.data.errno == 401) {
            // 清除登录相关内容
            try {
              wx.removeStorageSync('userInfo');
              wx.removeStorageSync('token');
            } catch (e) {
              // Do something when catch error
            }
            // 切换到登录页面
            wx.redirectTo({
              url: '/pages/index/index'
            });
          } else {
            resolve(res.data);
          }
        } else {
          reject(res.errMsg);
        }

      },
      fail: function (err) {
        reject(err)
      }
    })
  });
}

function showErrorToast(msg) {
  wx.showToast({
    title: msg,
    image: '/static/images/icon_error.png'
  })
}

function formatweek(date) {
  let week = date.getDay();
  let weekArr = '';
  switch (week) {
    case 1:
      weekArr = '周一';
      break;
    case 2:
      weekArr = '周二';
      break;
    case 3:
      weekArr = '周三';
      break;
    case 4:
      weekArr = '周四';
      break;
    case 5:
      weekArr = '周五';
      break;
    case 6:
      weekArr = '周六';
      break;
    case 0:
      weekArr = '周日';
      break;

  }
  return weekArr;

}

function getDateList(date, interval, length) {
  let dateList = [];
  let len = (length ? length : 7);
  for (let i = 0; i < len; i++) {
    let datestamp = new Date(date.getTime() + i * 60 * 60 * 1000 * 24 * interval);
    let dateItem = {
      week: formatweek(datestamp),
      date: formetdate(datestamp),
      id: new Date(datestamp).getDay()
    };
    dateList.push(dateItem);
  }
  return dateList;
}

function dateDifference(end) {
  // //比较2个日期 
  // console.log(start + ",," + end);
  // var stime = new Date(start).getTime();
  var stime = new Date().getTime();
  console.log(end.replace(/-/g, "/"));
  var etime = new Date(end.replace(/-/g, "/")).getTime();
  var usedTime = etime - stime; //两个时间戳相差的毫秒数

  var days = Math.floor(usedTime / (24 * 3600 * 1000));
  //计算出小时数
  var leave1 = usedTime % (24 * 3600 * 1000); //计算天数后剩余的毫秒数
  var hours = Math.floor(leave1 / (3600 * 1000));
  //计算相差分钟数
  var leave2 = leave1 % (3600 * 1000); //计算小时数后剩余的毫秒数
  var minutes = Math.floor(leave2 / (60 * 1000));
  if (days == 0 && hours == 0) {
    return minutes + "分钟";
  }
  if (days == 0) {
    return hours + "时" + minutes + "分钟";
  }
  var time = days + "天" + hours + "时" + minutes + "分钟";
  // var time = days;
  return time;
}

function formetdate(date) {
  var year = date.getFullYear();
  var month = date.getMonth() + 1;
  var day = date.getDate();
  return [year, month, day].map(formatNumber).join('-');
}

function getYearMonth(str,method){
            let arr = str.split('-');
            let year = arr[0]; //获取当前日期的年份
            let month = arr[1]; //获取当前日期的月份
      let total=0;
      if (method == '+') {
        total=Number(year*12+Number(month)+1).toFixed(0);
      } else if (method == '-') {
        total=Number(year*12+Number(month)-1).toFixed(0);
      }
      let year2=parseInt(total/12);
      let month2=total%12;
      if(month2==0){
        year2=parseInt(total/12)-1;
         month2=12;
      }
      if (month2 < 10) {
        month2 = '0' + month2;
       
    }
    let str2 = year2 + '-' + month2 ;
    return str2;


}
function getWeek(day) {
  let week=moment(day).format("W");
  return week;
} 
function chineseDate(day) {
  let date=moment(day).format("YYYY年MM月DD日");
  return date;
} 

function forMatTime(array){
  console.log("array",array);
  for(let i=0;i<array.length;i++){
     let newString = array[i].createTime.replace('T', ' ');
  newString = newString.slice(0,16)
  array[i].createTime=newString
    }
    return array
}

module.exports = {
  formatTime,
  formatDate,
  request,
  mathChangeDate,
  showErrorToast,
  getWeekByDate,
  formatweek,
  getDateList,
  dateDifference,
  formetdate,
  toDate,
  getYearMonth,
	getWeek,
	chineseDate,
	forMatTime
}